unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, ComCtrls, MMSystem;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnSelect: TButton;
    btnStart: TButton;
    btnStop: TButton;
    lblPos: TLabel;
    lblFile: TLabel;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    procedure btnSelectClick(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    SoundLen: integer;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  lblFile.Caption := '';
  lblPos.Caption := '0 %';
  SoundLen := 1;
end;

procedure TForm1.btnSelectClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    lblFile.Caption := OpenDialog1.FileName;
end;

procedure TForm1.btnStartClick(Sender: TObject);
var
  S: String;
begin
  mciSendString('stop mySound', nil, 0, 0);
  mciSendString('close mySound', nil, 0, 0);
  if lblFile.Caption = '' then
    ShowMessage('Please, select a file')
  else begin
    mciSendString(PChar('open "' + lblFile.Caption + '" alias mySound'), nil, 0, 0);
    mciSendString(PChar('play mySound') , nil, 0, 0);
    // get length of soundfile
    mciSendString('status mySound length', Pchar(S), 255, 0);
    TryStrToInt(Pchar(S), SoundLen);
    Timer1.Enabled := True;
  end;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  mciSendString(PChar('stop mySound'), nil, 0, 0);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  S: String;
  SoundPos: integer;
begin
  // get actual position in soundfile
  mciSendString('status mySound position', Pchar(S), 255, 0);
  if TryStrToInt(Pchar(S), SoundPos) then begin
    TrackBar1.Position := Round(100 * SoundPos/SoundLen);
    lblPos.Caption := IntToStr(TrackBar1.Position) + ' %';
  end;
  if Abs(SoundLen - SoundPos) < 5 then begin
    Timer1.Enabled := False;
    lblPos.Caption := '100 %';
  end;
end;

end.

